#!/bin/sh
#######################################################################
####################### themeleme.sh R 0.3.6 - the 2nd Generation
####################### Fatih Demir [ kabalak@gmx.net ]
####################### 2 November 1999 , Mannheim/Germany
#######################################################################
function kullanim () {
echo "<_-> -> Usage :                                             <-_>"
echo "<_->  +->  --help -help -h -? for this help                 <-_>"
echo "<_->   +->   --man --manual shows the man-page              <-_>"
echo "<_->    +->   --readme-style --style selects the Rstyle     <-_>"
echo "<_->     +->   --screenshot -sshot takes a screenshot       <-_>"
echo "<_->      +->   --delete --sil -d -s cleans all tmp-files   <-_>"
echo "<_->       +->   --make --makestyle makes a Rstyle with you <-_>"
echo "<_->        +->   --list Lists all former packed WM-Themes  <-_>"
echo "<_-> ###################################################### <-_>"
}
function oencekiler_ ()  {
echo "<_-> Your former with themeleme.sh made WindowMaker-themes :"
cat ~/.themeleme.sh/.themeleme.sh.Slar
}
function Rstylle_ ()  {
echo "<_-> Name of the .Rstyle : "
	read -p "<_->  " Rstyle
	if [ -z Rstyle ] ; then
		echo "<_-> You gave no Rstyle-name ! " 
		echo "<_-> The .Rstyle will be named MyRstyle.Rstyle ! "
		Rstyle=MyRstyle
	fi
echo "<_-> What should be the character which fills the line : "
	read -p "<_->  " Rfchar
echo "<_-> The header of the READMEs made with this .Rstyle : "		
	read -p "<_->  " Rheader
echo "<_-> The footer of the READMEs made with this .Rstyle : "
	read -p "<_->  " Rfooter
echo "<_-> Your name : "
	read -p "<_->  " Ryazar
	if [ -z Ryazar ] ; then 
		echo "<_-> As you didn't gave your name the author's name is Anonymous ! "
		Ryazar=Anonymous
	fi
echo "<_-> Your EMail address : "
	read -p "<_->  " Reposta
	if [ -z Reposta ] ; then
		echo "<_-> I predict that you haven't got an EMail address ! "
		Reposta=HasGotNoOneYetOrDidntWantToTellYou
	fi
	Rstylle_yaz_
} 
function Rstylle_yaz_ () {
echo -ne "#################### README-style for themeleme.sh R 0.3.5+ #####################" > .RS_BAS
echo -ne "\n#################### style-name   : $Rstyle" > .RS_S
echo -ne "\n#################### style-Author : $Ryazar $Reposta " > .RS_A
echo -ne "\n#################################################################################" > .RS_
echo -ne "\nTHEMELEME_SH_H=$Rfchar" > .RS_H
echo -ne "\nTHEMELEME_SH_BAS=$Rheader" > .RS_HEADER
echo -ne "\nTHEMELEME_SH_SON=$Rfooter" > .RS_FOOTER
cat .RS_BAS .RS_ .RS_S .RS_A .RS_ .RS_H .RS_HEADER .RS_FOOTER .RS_ > $Rstyle.Rstyle
[ -f $Rstyle.Rstyle ] && rm -f .RS_* && \
echo "<_-> The $Rstyle.Rstyle has been written  ! "
echo "<_-> ###################################################### <-_>"
exit 0
}
function sonluk ()  {
echo "<_-> Packing everything .........                           <-_>"
[ -d $ad.themed ] && tar czf $ad.tar.gz $ad.themed && \
echo "<_-> Taking screenshot for $ad-theme ......      "
xwd -root|convert - $ad.jpg
echo "<_-> ###################################################### <-_>"
echo "<_-> The screenshot is `pwd`/$ad.jpg !"
echo "<_-> ###################################################### <-_>"
echo "<_-> ##################### Bye Bye ######################## <-_>"
exit 0
}
function sonluk_2 ()  {
echo "<_-> ###################################################### <-_>"
echo "<_-> ##################### Bye Bye ######################## <-_>"
exit 0
}
function theme_ekle ()  {
[ -d $ad.themed ] && mv -f $ad.themed ~/[gG]*step/[lL]ibrary/[wW]indow*ker/[tT]hemes/ && \
echo "<_-> $ad-theme has been moved to your WM-Themes directory . "
}
function saR ()  {
echo "<_-> ###################################################### <-_>"
echo "<_-> semi-auto-README mechanism : You type , I \"design\"     <-_>"
echo "<_-> Your name , the authors  :"
read -p "<_->   " yazman
echo "<_-> Your EMail-address :"
read -p "<_->   " eposta
echo "<_-> The homepage of you (without http://) : "
read -p "<-_>   " _site
echo "<_-> Where have you designed this theme :"
read -p "<_->   " mekan
echo "<_-> What caused you to make a theme :"
read -p "<_->   " neden
echo "<_-> Some additional words :"
read -p "<_->   " soez
saR_yaz
}
function saR_yaz ()  {
saR_yaz_baslik && saR_yaz_bilgi && saR_yaz_son 
}
function saR_yaz_baslik ()  {
echo "<_-> ###################################################### <-_>"
echo "<_-> Making the semi-auto-README ....                       <-_>"
Q=$THEMELEME_SH_H 
W=$THEMELEME_SH_BAS
E=$THEMELEME_SH_SON
}
function saR_yaz_bilgi ()  {
echo -en "\n$W" > R_a &&   
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q $ad-theme for WM         "  > R_b &&  
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q$Q" > R_ &&  
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q Its a theme by : $yazman" > R_d &&  
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q EMail :  $eposta  " > R_f && 
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q Homepage : http://$_site " > R_f_3 &&
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q Date : `date` "  > R_h && 
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q Where have this been made : $mekan "  > R_j && 
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q Because :  $neden"  > R_l && 
echo -en "\n$Q$Q$Q$Q$Q$Q$Q$Q And I would like to say that : \n$Q$Q$Q$Q$Q$Q$Q$Q  $soez" > R_n &&
echo -en "\n$E" > R_z 
}
function saR_yaz_son ()  { 
cat R_a R_b R_ R_d R_ R_f R_ R_f_3 R_ R_h R_ R_j R_ R_l R_ R_n R_ R_z > $ad-README && \
rm R_* && \
echo "<_-> The README is written and styled !                     <-_>"
	cd .. && \
echo "<_->  -> It should be done , by the way ......              <-_>"
targzlik
echo "<_-> ###################################################### <-_>"
echo "<_-> ###################################################### <-_>"
}
function targzlik ()  {
echo "<_-> ###################################################### <-_>"
echo "<_-> Shall I add the $ad-theme to your theme-dir ?  "
read -p "<_-> " kar
	case $kar in
	Yes|yes|y)
	echo "<_-> Adding to your theme dir ....                          <-_>"
	theme_ekle && \
	sonluk
	;;
	No|no|n)
	sonluk
	;;
	esac
}
function _themele ()  {
echo "<_-> ###################################################### <-_>"
echo "<_->       -> themeleme.sh - the 2nd Generation :           <-_>"
echo "<_->        +-> What should be the name of the theme ?      <-_>"
echo "<_->         +-> You can quit the programm with q/Q !       <-_>"
read -p "<_->           " ad
case $ad in
"")
echo "<_->       -> Please give a theme name                      <-_>"
_themele
;;
q|Q)
sonluk_2
;;
esac
echo "<_->         +-> Is the theme-name right ?                  <-_>"
echo "<_->          Theme name : $ad    (Yes/No/y/n/yes/no)        "
read -p "<_->           " kar
case $kar in
Yes|y|yes)
echo -e "\n On `date` : \n $ad.themed \n $ad.tar.gz \n Made by $USER " > ~/.themeleme.sh/.themeleme.sh-$$
[ -f ~/.themeleme.sh/.themeleme.sh.Slar ] && mv -f  ~/.themeleme.sh/.themeleme.sh.Slar  ~/.themeleme.sh/.themeleme.sh.Slar_
cat ~/.themeleme.sh/.themeleme.sh-$$ ~/.themeleme.sh/.themeleme.sh.Slar_ > ~/.themeleme.sh/.themeleme.sh.Slar
[ -d $ad.themed ] && eskile_
getstyle --pack $ad
	echo '<_->                                                        <-_>'
	echo "<_-> Write a README now ?                                   <-_>"
		read -p "<_-> " kar
		case $kar in
		n|no|No|NO|q|Q|c|C)
                echo "<_-> Ok , lets get used again !                            <_->"
		sonluk
		;;
		*)
                [ -d $ad.themed ] && cd $ad.themed && saR && \
                echo "<_-> Ok , it should be done !                               <_->"
                sonluk
                ;;
		esac
;;
No|n|no)
echo "<_->         Ok , lets try it again .....                     <-_>"
_themele
;;
Q|q|quit|exit)
sonluk_2
exit 0
;;
esac
}
function eskile_  ()  {
echo "<_-> Have found a .themed with the same name as your theme  <-_>"
echo "<_-> ###################################################### <-_>"
echo "<_-> Would you like to rename it ?                          <-_>"
echo "<_-> ( If you don't enter a name the older one will be      <-_>"
echo "<_->  named to $ad.themed_old               "
	read -p "<_-> " isim
	case $isim in
	y|Y|yes|Yes|YES|yES|yeS|YEs|e|E|evet|EVET|Evet)
	isimle_
	;;
	*)
	echo "<_-> Renaming the old one to $ad.themed_old        "
	[ -d $ad.themed ] && mv -f $ad.themed $ad.themed_old 
	[ -d $ad.themed_old ] && 	echo "<_-> Done .                               <-_>"
	;;
	esac
}
function isimle_  ()  {
echo "<_-> Rename $ad.themed to : "
	read -p "<_-> " yeni_isim
	case $yeni_isim in
	*)
	mv -f $ad.themed $yeni_isim
	[ -d "$yeni_isim" ] && echo "<_-> Done .                                       <-_>"
	;;
	esac
}
echo ""
echo "<_-> ###################################################### <-_>"
echo "<_->       -> themeleme.sh R 0.3.6 - the 2nd Generation     <-_>"
echo "<_->        +-> 2 Nov 1999 , Fatih Demir [kabalak@gmx.net]  <-_>"
echo "<_->         +-> Of course , GPL V2.0-compliant .           <-_>"
echo "<_->          +-> For help , press : --help -help -h -?     <-_>"
echo "<_->           +-> Man-page can be called by --man --manual <-_>"
echo "<_-> ###################################################### <-_>"
[ -d ~/.themeleme.sh ] || mkdir -f ~/.themeleme.sh && \
export THEMELEME_SH_H=#
export THEMELEME_SH_BAS=##############################Readme###############################
export THEMELEME_SH_SON=###################################################################
function ekranla_ ()  {
echo "<_-> ###################################################### <-_>"
case $2 in
" ")
echo "<_-> What should be the name of the screenshot ?            <-_>"
read -p "<_-> " kar
	case $kar in
	" ")
	echo "<_-> Your screenshot will be named Screenshot_$$.jpg !        <-_>"
	xwd -root|convert - Screenshot_$$.jpg && \
	echo "<_-> Screenshot_$$.jpg has benn taken !                       <-_>"
	sonluk
	;;
	*)
	echo "<_-> Taking the $kar screenshot ....        "
	export THEMELEME_SH_RESMI=$kar
	resimle_
	;;
	esac
;;
*.*)
echo "<_-> Taking screnshot $2 ....." 
export THEMELEME_SH_RESMI=$2
resimle_
;;
esac
}
function resimle_ ()  {
xwd -root|convert - $THEMELEME_SH_RESMI && \
echo "<_-> It should be finished !                                <-_>"
sonluk_2
}
#######################################################################
case $1 in
--help|-help|-h|-?)
kullanim
;;
--man|--manual)
man themeleme.sh
;;
    --readme-style|--style)
    case $2 in
    "")
    echo "<_-> Discarding your readme-style option (are there any ?) <-_>"
    _themele
    ;;
    *)
    [ -f $2 ] && export THEMELEME_SH_TIP=$2 && \
    export `grep THEMELEME_SH_H $THEMELEME_SH_TIP` && \
    export `grep THEMELEME_SH_BAS $THEMELEME_SH_TIP` && \
    export `grep THEMELEME_SH_SON $THEMELEME_SH_TIP` && \
    _themele
    ;;
    esac
;;
-s|-sshot|--screenshot)
ekranla_
;;
--delete|--clean|-d|-s|--sil)
echo "<-_> Cleaning all temp-files  ......                        <-_>" && \
[ -f ~/.themeleme.sh/.themeleme.* ] && rm ~/.themeleme.sh/.themeleme.* && \
echo "<_-> Cleaned all temporary files !                          <-_>"
;;
--list|--previous|-l)
oencekiler_
;;
--make|--makestyle|--makeRstyle)
Rstylle_
;;
*)
_themele
;;
esac
#######################################################################
